// Mistrz.cpp: implementation of the CMistrz class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "scrab.h"
#include "Mistrz.h"
#include "Scrabdlg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CMistrz::CMistrz()
{

		// konstruktor

		// dodajemy zestaw literek
	Worek.dodaj('N');	Worek.dodaj('N');	Worek.dodaj('N');	Worek.dodaj('E');	Worek.dodaj('E');
	Worek.dodaj('K');	Worek.dodaj('L');	Worek.dodaj('L');	Worek.dodaj('L');	Worek.dodaj('');
	Worek.dodaj('');	Worek.dodaj('M');	Worek.dodaj('M');	Worek.dodaj('M');	Worek.dodaj('N');
	Worek.dodaj(' ');	Worek.dodaj('A');	Worek.dodaj('A');	Worek.dodaj('A');	Worek.dodaj('A');
	Worek.dodaj('C');	Worek.dodaj('');	Worek.dodaj('D');	Worek.dodaj('D');	Worek.dodaj('D');
	Worek.dodaj('G');	Worek.dodaj('H');	Worek.dodaj('H');	Worek.dodaj('I');	Worek.dodaj('I');
	Worek.dodaj('E');	Worek.dodaj('E');	Worek.dodaj('');	Worek.dodaj('F');	Worek.dodaj('G');
	Worek.dodaj('I');	Worek.dodaj('J');	Worek.dodaj('J');	Worek.dodaj('K');	Worek.dodaj('K');
	Worek.dodaj('Z');	Worek.dodaj('Z');	Worek.dodaj('');	Worek.dodaj('');	Worek.dodaj(' ');
	Worek.dodaj('I');	Worek.dodaj('I');	Worek.dodaj('I');	Worek.dodaj('I');	Worek.dodaj('I');
	Worek.dodaj('E');	Worek.dodaj('E');	Worek.dodaj('E');	Worek.dodaj('N');	Worek.dodaj('');
	Worek.dodaj('R');	Worek.dodaj('R');	Worek.dodaj('R');	Worek.dodaj('R');	Worek.dodaj('S');
	Worek.dodaj('S');	Worek.dodaj('S');	Worek.dodaj('S');	Worek.dodaj('');	Worek.dodaj('T');
	Worek.dodaj('O');	Worek.dodaj('O');	Worek.dodaj('O');	Worek.dodaj('O');	Worek.dodaj('O');
	Worek.dodaj('T');	Worek.dodaj('T');	Worek.dodaj('U');	Worek.dodaj('U');	Worek.dodaj('W');
	Worek.dodaj('A');	Worek.dodaj('A');	Worek.dodaj('A');	Worek.dodaj('A');	Worek.dodaj('A');
	Worek.dodaj('O');	Worek.dodaj('');	Worek.dodaj('P');	Worek.dodaj('P');	Worek.dodaj('P');
	Worek.dodaj('W');	Worek.dodaj('W');	Worek.dodaj('W');	Worek.dodaj('Y');	Worek.dodaj('Y');
	Worek.dodaj('');	Worek.dodaj('B');	Worek.dodaj('B');	Worek.dodaj('C');	Worek.dodaj('C');
	Worek.dodaj('Y');	Worek.dodaj('Y');	Worek.dodaj('Z');	Worek.dodaj('Z');	Worek.dodaj('Z');
	
		//czycimy plansz
	int i,j;
	for (i=0; i<15; i++)
		for (j=0; j<15; j++)
			Plansza[i][j]=NULL;

}

CMistrz::~CMistrz()
{

}


void CMistrz::WyslijLiterki(int ile, int komu)	//wysya do klienta nowe literki
{
	int i;
	char n;
	for (i=0; i<ile; i++)
	{
		n=Worek.losuj();	// losuje literk
		if (n)
		{	// L - nagwek oznaczajcy literk
			((CScrabDlg*)m_pWnd)->Wyslij(komu, '0', 'L', n);
		}
		if ((!n)&&(ile=i-1))
		{
			//sprawdz czy klient ma literki jeszcze
			((CScrabDlg*)m_pWnd)->Wyslij(komu, '0', '!', " ");
		}
	}
}

void CMistrz::UstawOjca(CDialog *pWnd)
{
	//ustawienie pola wskanika do nadrzdnego okna dialogowego
	m_pWnd = pWnd;
}



void CMistrz::Startuj()
{
	//Losuje i rozsya kademu literki
	
	//sprawdza czy gracz jest
	int n;
	Players=0;
	for (n=1; n<5; n++)
		if (((CScrabDlg*)m_pWnd)->m_Gracz[n].m_bPolaczony)
		{
			Players++;
			WyslijLiterki(7, n);
		}
}

void CMistrz::SprawdzLiterki()
{
	Punkty=0;
//	((CScrabDlg*)m_pWnd)->WypiszKom("poczatek sprawdzania punktw");
	//odczytuje sowa i wysya do klientw
	
	//sprawdzamy czy jest pionowe czy poziome
	if (literki[0].kolumna==literki[1].kolumna)
	{
		// sowo pionowe		(kolumna,wiersz)

		// 1 - sowo wzdu liter
		Slowa[0]=ZwrocSlowo(1,literki[0].kolumna,literki[0].wiersz);		
		Punkty=ZwrocPunkty(1,literki[0].kolumna,literki[0].wiersz);		

		// 2 - sowa wszerz
		for (int i=0; i<7; i++)
		{
			if(literki[i].kolumna!=0)
			{
				Slowa[i+1]=ZwrocSlowo(0,literki[i].kolumna,literki[i].wiersz);
				if (Slowa[i+1].GetLength()>1)
					Punkty+=ZwrocPunkty(0,literki[i].kolumna,literki[i].wiersz);
			}

		}


	}
	else
	{
		//sowo poziome

		// 1 - sowo wzdu liter
		Slowa[0]=ZwrocSlowo(0,literki[0].kolumna,literki[0].wiersz);		
		Punkty=ZwrocPunkty(0,literki[0].kolumna,literki[0].wiersz);		
		// 2 - sowa wszerz
		for (int i=0; i<7; i++)
		{
			if(literki[i].kolumna!=0)
			{
				Slowa[i+1]=ZwrocSlowo(1,literki[i].kolumna,literki[i].wiersz);
				if (Slowa[i+1].GetLength()>1)
					Punkty+=ZwrocPunkty(1,literki[i].kolumna,literki[i].wiersz);
			}

		}


	}

	//((CScrabDlg*)m_pWnd)->WypiszKom("punkty sprawdzone");


	for(int j=1;j<5;j++)
		glosowanie[j].bDone=FALSE;

	glosowanie[Klient].bAccept=TRUE;
	glosowanie[Klient].bDone=TRUE;
	WyslijKomunikaty();
}



char CMistrz::ZwrocLitere(int x, int y)
{
	if(Plansza[x][y])
	{
	   	//((CScrabDlg*)m_pWnd)->WypiszKom("Na planszy");
		return(Plansza[x][y]);
	}
	else
	{
	  // 	((CScrabDlg*)m_pWnd)->WypiszKom("Poza plansza");
		for (int i=0;i<7;i++)
		{
			if ((literki[i].wiersz==y)&&(literki[i].kolumna==x))
				if(literki[i].literka==' ')
				{ //zwr zastpcz
					return(Zastepcza(x,y));
				}
				else
					return(literki[i].literka);
		}

	}
   	//((CScrabDlg*)m_pWnd)->WypiszKom("Nie znalaz");
	return(NULL);
}

CString CMistrz::ZwrocSlowo(BOOL pion, int n, int m)
{
	CString temp;
	char x;
	int f;
if (pion)
{
	f=m;
	x=ZwrocLitere(n,m);
	while((x!=NULL)&&(m>0))
	{
		temp=x+temp;
		m--;
		x=ZwrocLitere(n,m);
	}

	//do dou
	m=f+1;
	x=ZwrocLitere(n,m);
	while((x!=NULL)&&(m<16))
	{
		temp=temp+x;
		m++;
		x=ZwrocLitere(n,m);
	}
}
else
{
	f=n;
	x=ZwrocLitere(n,m);
	while((x!=NULL)&&(n>0))
	{
		temp=x+temp;
		n--;
		x=ZwrocLitere(n,m);
	}

	//do dou
	n=f+1;
	x=ZwrocLitere(n,m);
	while((x!=NULL)&&(n<16))
	{
		temp=temp+x;
		n++;
		x=ZwrocLitere(n,m);
	}
}

return(temp);
}

void CMistrz::WyslijKomunikaty()
{
	CString komunikat;

	for(int i=0; i<8; i++)
	{
		if(Slowa[i].GetLength()>1)
		{
			komunikat=komunikat+'\n'+Slowa[i];
			Slowa[i].Empty();
		}

	}
	
	for(i=4; i>0; i--)
	{
		if(i!=Klient)
			((CScrabDlg*)m_pWnd)->Wyslij(i,Klient+48,'K',komunikat);
	}

}

void CMistrz::Sprawdzone()
{
	CString kom;
	BOOL wynik=TRUE;
	//Wszyscy podjeli decyzje
//	((CScrabDlg*)m_pWnd)->WypiszKom("Wszyscy podjeli decyzje");
		for (int n=1; n<5; n++)
			if (glosowanie[n].bDone==TRUE)
				if (glosowanie[n].bAccept==FALSE)
					wynik=FALSE;

	if (!wynik)			
	{
		//ze sowa
		//Wylij komunikat do klienta
		((CScrabDlg*)m_pWnd)->Wyslij(Klient, '0', 'E', "");

	}
	else
	{
		//dobre sowa
		((CScrabDlg*)m_pWnd)->Wyslij(Klient, '0', 'T', "");
		
		//wylij literki do wszystkich
		for(int i=0; i<8; i++)
			if (literki[i].kolumna!=0)
			{
				if(literki[i].literka==' ')
				{
					kom=(CString)DajMaslo(Zastepcza(literki[i].kolumna,literki[i].wiersz))+(CString)literki[i].kolumna+(CString)literki[i].wiersz;
					Plansza[literki[i].kolumna][literki[i].wiersz]=Zastepcza(literki[i].kolumna,literki[i].wiersz);
				}
				else
				{
					kom=(CString)literki[i].literka+(CString)literki[i].kolumna+(CString)literki[i].wiersz;
					Plansza[literki[i].kolumna][literki[i].wiersz]=literki[i].literka;
				}
				for (int m=2; m<5; m++)
				if (((CScrabDlg*)m_pWnd)->m_Gracz[m].m_bPolaczony)
				{
					((CScrabDlg*)m_pWnd)->Wyslij(m,'0','W',kom);
				}
				temp[i].kolumna=literki[i].kolumna;
				temp[i].wiersz=literki[i].wiersz;
				temp[i].literka=literki[i].literka;
				literki[i].kolumna=0;
				literki[i].wiersz=0;
			}

		//wylij nowe literki do klienta
		WyslijLiterki(IleLiter, Klient);

//		((CScrabDlg*)m_pWnd)->WypiszKom("dodaj punkty");

		((CScrabDlg*)m_pWnd)->m_Gracz[Klient].m_nPunkty+=Punkty;
		WyslijPunkty();
		AktywnyKlient=NastepnyGracz(AktywnyKlient);
		((CScrabDlg*)m_pWnd)->Wyslij(AktywnyKlient, '0', 'U', " ");
		Rezygnacje=0;
	}
}

int CMistrz::NastepnyGracz(int n)
{
	int i=n+1;
	if (i==5) return(1);
	
	if (((CScrabDlg*)m_pWnd)->m_Gracz[i].m_bPolaczony)
		return(i);
	else
		return(NastepnyGracz(i));

}

int CMistrz::PunktLiterki(char litera)
{

	switch(litera)
	{
	case '':
		return(5);
		break;
	case '':
		return(6);
		break;
	case '':
		return(5);
		break;
	case '':
		return(3);
		break;
	case '':
		return(7);
		break;
	case '':
		return(5);
		break;
	case '':
		return(5);
		break;
	case '':
		return(9);
		break;
	case '':
		return(5);
		break;
	case 'A':
		return(1);
		break;
	case 'B':
		return(3);
		break;
	case 'C':
		return(2);
		break;
	case 'D':
		return(2);
		break;
	case 'E':
		return(1);
		break;
	case 'F':
		return(5);
		break;
	case 'G':
		return(3);
		break;
	case 'H':
		return(3);
		break;
	case 'I':
		return(1);
		break;
	case 'J':
		return(3);
		break;
	case 'K':
		return(2);
		break;
	case 'L':
		return(2);
		break;
	case 'M':
		return(2);
		break;
	case 'N':
		return(1);
		break;
	case 'O':
		return(1);
		break;
	case 'P':
		return(2);
		break;
	case 'R':
		return(1);
		break;
	case 'S':
		return(1);
		break;
	case 'T':
		return(2);
		break;
	case 'U':
		return(3);
		break;
	case 'W':
		return(1);
		break;
	case 'Y':
		return(2);
		break;
	case 'Z':
		return(1);
		break;
	case ' ':
		return(0);
		break;
	}
return(0);
}

int CMistrz::ZwrocPunkty(BOOL pion, int n, int m)
{
	int punkty=0;
	char x;
	int f;
	if (pion)
	{
	f=m;
	x=ZwrocLitere1(n,m);
	while((x!=NULL)&&(m>0))
	{
		if (dwarazy(n,m))
		{
			punkty+=2*PunktLiterki(x);
		}
		else
			if (trzyrazy(n,m))
			{
				punkty+=3*PunktLiterki(x);
			}
			else
			{
				punkty+=PunktLiterki(x);
			}
		m--;
		x=ZwrocLitere1(n,m);

	}

	//do dou
	m=f+1;
	x=ZwrocLitere1(n,m);
	while((x!=NULL)&&(m<16))
	{
		if (dwarazy(n,m))
		{
			punkty+=2*PunktLiterki(x);
		}
		else
			if (trzyrazy(n,m))
			{
				punkty+=3*PunktLiterki(x);
			}
			else
			{
				punkty+=PunktLiterki(x);
			}		m++;
		x=ZwrocLitere1(n,m);
	}
	}
	else
	{
	f=n;
	x=ZwrocLitere1(n,m);
	while((x!=NULL)&&(n>0))
	{
		if (dwarazy(n,m))
		{
			punkty+=2*PunktLiterki(x);
		}
		else
			if (trzyrazy(n,m))
			{
				punkty+=3*PunktLiterki(x);
			}
			else
			{
				punkty+=PunktLiterki(x);
			}
		n--;
		x=ZwrocLitere1(n,m);
	}

	//do dou
	n=f+1;
	x=ZwrocLitere1(n,m);
	while((x!=NULL)&&(n<16))
	{
		if (dwarazy(n,m))
		{
			punkty+=2*PunktLiterki(x);
		}
		else
			if (trzyrazy(n,m))
			{
				punkty+=3*PunktLiterki(x);
			}
			else
			{
				punkty+=PunktLiterki(x);
			}
		n++;
		x=ZwrocLitere1(n,m);
	}
	}


	//sprawdz pola specjalne
		for (int i=0; i<7; i++)
		{
			if(dwarazys(literki[i].kolumna, literki[i].wiersz))
				punkty*=2;

			if(trzyrazys(literki[i].kolumna, literki[i].wiersz))
				punkty*=3;

		}
return(punkty);

}

BOOL CMistrz::dwarazy(int kol, int wie)
{
	if ((kol==1)&&(wie==4)) return(TRUE);
	if ((kol==1)&&(wie==12)) return(TRUE);
	if ((kol==3)&&(wie==7)) return(TRUE);
	if ((kol==3)&&(wie==9)) return(TRUE);
	if ((kol==4)&&(wie==1)) return(TRUE);
	if ((kol==4)&&(wie==8)) return(TRUE);
	if ((kol==4)&&(wie==15)) return(TRUE);
	if ((kol==7)&&(wie==3)) return(TRUE);
	if ((kol==7)&&(wie==7)) return(TRUE);
	if ((kol==7)&&(wie==9)) return(TRUE);
	if ((kol==7)&&(wie==13)) return(TRUE);
	if ((kol==8)&&(wie==4)) return(TRUE);
	if ((kol==8)&&(wie==12)) return(TRUE);
	if ((kol==9)&&(wie==3)) return(TRUE);
	if ((kol==9)&&(wie==7)) return(TRUE);
	if ((kol==9)&&(wie==9)) return(TRUE);
	if ((kol==9)&&(wie==13)) return(TRUE);
	if ((kol==12)&&(wie==1)) return(TRUE);
	if ((kol==12)&&(wie==8)) return(TRUE);
	if ((kol==12)&&(wie==15)) return(TRUE);
	if ((kol==13)&&(wie==7)) return(TRUE);
	if ((kol==13)&&(wie==9)) return(TRUE);
	if ((kol==15)&&(wie==4)) return(TRUE);
	if ((kol==15)&&(wie==12)) return(TRUE);
return(FALSE);
}

BOOL CMistrz::trzyrazy(int kol, int wie)
{
	if ((kol==2)&&(wie==6)) return(TRUE);
	if ((kol==2)&&(wie==10)) return(TRUE);
	if ((kol==6)&&(wie==6)) return(TRUE);
	if ((kol==6)&&(wie==10)) return(TRUE);
	if ((kol==6)&&(wie==2)) return(TRUE);
	if ((kol==6)&&(wie==14)) return(TRUE);
	if ((kol==10)&&(wie==14)) return(TRUE);
	if ((kol==10)&&(wie==2)) return(TRUE);
	if ((kol==10)&&(wie==6)) return(TRUE);
	if ((kol==10)&&(wie==10)) return(TRUE);
	if ((kol==14)&&(wie==6)) return(TRUE);
	if ((kol==14)&&(wie==10)) return(TRUE);
return(FALSE);

}

BOOL CMistrz::dwarazys(int kol, int wie)
{
	if ((kol==8)&&(wie==8)) return(TRUE);

	if ((kol==2)&&(wie==2)) return(TRUE);
	if ((kol==3)&&(wie==3)) return(TRUE);
	if ((kol==4)&&(wie==4)) return(TRUE);
	if ((kol==5)&&(wie==5)) return(TRUE);

	if ((kol==2)&&(wie==14)) return(TRUE);
	if ((kol==3)&&(wie==13)) return(TRUE);
	if ((kol==4)&&(wie==12)) return(TRUE);
	if ((kol==5)&&(wie==11)) return(TRUE);

	if ((kol==14)&&(wie==2)) return(TRUE);
	if ((kol==13)&&(wie==3)) return(TRUE);
	if ((kol==12)&&(wie==4)) return(TRUE);
	if ((kol==11)&&(wie==5)) return(TRUE);

	if ((kol==14)&&(wie==14)) return(TRUE);
	if ((kol==13)&&(wie==13)) return(TRUE);
	if ((kol==12)&&(wie==12)) return(TRUE);
	if ((kol==11)&&(wie==11)) return(TRUE);
return(FALSE);
}

BOOL CMistrz::trzyrazys(int kol, int wie)
{
	if ((kol==1)&&(wie==1)) return(TRUE);
	if ((kol==1)&&(wie==15)) return(TRUE);
	if ((kol==15)&&(wie==1)) return(TRUE);
	if ((kol==15)&&(wie==15)) return(TRUE);
	if ((kol==1)&&(wie==8)) return(TRUE);
	if ((kol==8)&&(wie==1)) return(TRUE);
	if ((kol==15)&&(wie==8)) return(TRUE);
	if ((kol==8)&&(wie==15)) return(TRUE);
return(FALSE);
}

void CMistrz::WyslijPunkty()
{
	char temp[8];
	for(int i=1; i<5; i++)
	{
		itoa(((CScrabDlg*)m_pWnd)->m_Gracz[1].m_nPunkty,temp,10);
		((CScrabDlg*)m_pWnd)->Wyslij(i,'1','P',temp);
		itoa(((CScrabDlg*)m_pWnd)->m_Gracz[2].m_nPunkty,temp,10);
		((CScrabDlg*)m_pWnd)->Wyslij(i,'2','P',temp);
		itoa(((CScrabDlg*)m_pWnd)->m_Gracz[3].m_nPunkty,temp,10);
		if (((CScrabDlg*)m_pWnd)->m_Gracz[3].m_bPolaczony) ((CScrabDlg*)m_pWnd)->Wyslij(i,'3','P',temp);
		itoa(((CScrabDlg*)m_pWnd)->m_Gracz[4].m_nPunkty,temp,10);
		if (((CScrabDlg*)m_pWnd)->m_Gracz[4].m_bPolaczony) ((CScrabDlg*)m_pWnd)->Wyslij(i,'4','P',temp);
	}

}

void CMistrz::Zakoncz()
{

	for(int i=2; i<5; i++)
	{
		((CScrabDlg*)m_pWnd)->Wyslij(i,'0','Q'," ");
	}
	((CScrabDlg*)m_pWnd)->GetDlgItem(IDC_PLAY)->EnableWindow(FALSE);
	((CScrabDlg*)m_pWnd)->GetDlgItem(IDC_RESIGN)->EnableWindow(FALSE);
	((CScrabDlg*)m_pWnd)->GetDlgItem(IDC_CHANGE)->EnableWindow(FALSE);
	((CScrabDlg*)m_pWnd)->KoniecGry();
	((CScrabDlg*)m_pWnd)->Koniec=TRUE;
}



char CMistrz::Zastepcza(int kol, int wie)
{
	char znak;
	znak=mydlo[0].literka;
	if ((mydlo[1].literka!=' ')&&(mydlo[1].kolumna==kol)&&(mydlo[1].wiersz==wie))
		znak=mydlo[1].literka;
return(znak);
}

char CMistrz::ZwrocLitere1(int x, int y)
{
	if(Plansza[x][y])
	{
	   	//((CScrabDlg*)m_pWnd)->WypiszKom("Na planszy");
		return(Plansza[x][y]);
	}
	else
	{
	  // 	((CScrabDlg*)m_pWnd)->WypiszKom("Poza plansza");
		for (int i=0;i<7;i++)
		{
			if ((literki[i].wiersz==y)&&(literki[i].kolumna==x))
					return(literki[i].literka);
		}

	}
   	//((CScrabDlg*)m_pWnd)->WypiszKom("Nie znalaz");
	return(NULL);

}

char CMistrz::DajMaslo(char m)
{
	if ((m>'A'-1)&&(m<'Z'+1))
		return(m+'a'-'A');
	if (m=='')
		return('');
	if (m=='')
		return('');
	if (m=='')
		return('');
	if (m=='')
		return('');
	if (m=='')
		return('');
	if (m=='')
		return('');
	if (m=='')
		return('');
	if (m=='')
		return('');
	if (m=='')
		return('');
	return('');
}
